import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { CreateAppInstanceAdminResponseFilterSensitiveLog, } from "../models/models_0";
import { de_CreateAppInstanceAdminCommand, se_CreateAppInstanceAdminCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class CreateAppInstanceAdminCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeIdentityService", "CreateAppInstanceAdmin", {})
    .n("ChimeSDKIdentityClient", "CreateAppInstanceAdminCommand")
    .f(void 0, CreateAppInstanceAdminResponseFilterSensitiveLog)
    .ser(se_CreateAppInstanceAdminCommand)
    .de(de_CreateAppInstanceAdminCommand)
    .build() {
}
