import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { CreateAppInstanceBotRequestFilterSensitiveLog, } from "../models/models_0";
import { de_CreateAppInstanceBotCommand, se_CreateAppInstanceBotCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class CreateAppInstanceBotCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeIdentityService", "CreateAppInstanceBot", {})
    .n("ChimeSDKIdentityClient", "CreateAppInstanceBotCommand")
    .f(CreateAppInstanceBotRequestFilterSensitiveLog, void 0)
    .ser(se_CreateAppInstanceBotCommand)
    .de(de_CreateAppInstanceBotCommand)
    .build() {
}
