import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { DescribeAppInstanceResponseFilterSensitiveLog, } from "../models/models_0";
import { de_DescribeAppInstanceCommand, se_DescribeAppInstanceCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class DescribeAppInstanceCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeIdentityService", "DescribeAppInstance", {})
    .n("ChimeSDKIdentityClient", "DescribeAppInstanceCommand")
    .f(void 0, DescribeAppInstanceResponseFilterSensitiveLog)
    .ser(se_DescribeAppInstanceCommand)
    .de(de_DescribeAppInstanceCommand)
    .build() {
}
