import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { DescribeAppInstanceUserEndpointResponseFilterSensitiveLog, } from "../models/models_0";
import { de_DescribeAppInstanceUserEndpointCommand, se_DescribeAppInstanceUserEndpointCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class DescribeAppInstanceUserEndpointCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeIdentityService", "DescribeAppInstanceUserEndpoint", {})
    .n("ChimeSDKIdentityClient", "DescribeAppInstanceUserEndpointCommand")
    .f(void 0, DescribeAppInstanceUserEndpointResponseFilterSensitiveLog)
    .ser(se_DescribeAppInstanceUserEndpointCommand)
    .de(de_DescribeAppInstanceUserEndpointCommand)
    .build() {
}
