import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { ListAppInstanceUserEndpointsRequestFilterSensitiveLog, ListAppInstanceUserEndpointsResponseFilterSensitiveLog, } from "../models/models_0";
import { de_ListAppInstanceUserEndpointsCommand, se_ListAppInstanceUserEndpointsCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class ListAppInstanceUserEndpointsCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeIdentityService", "ListAppInstanceUserEndpoints", {})
    .n("ChimeSDKIdentityClient", "ListAppInstanceUserEndpointsCommand")
    .f(ListAppInstanceUserEndpointsRequestFilterSensitiveLog, ListAppInstanceUserEndpointsResponseFilterSensitiveLog)
    .ser(se_ListAppInstanceUserEndpointsCommand)
    .de(de_ListAppInstanceUserEndpointsCommand)
    .build() {
}
