import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { UpdateAppInstanceRequestFilterSensitiveLog, } from "../models/models_0";
import { de_UpdateAppInstanceCommand, se_UpdateAppInstanceCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class UpdateAppInstanceCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeIdentityService", "UpdateAppInstance", {})
    .n("ChimeSDKIdentityClient", "UpdateAppInstanceCommand")
    .f(UpdateAppInstanceRequestFilterSensitiveLog, void 0)
    .ser(se_UpdateAppInstanceCommand)
    .de(de_UpdateAppInstanceCommand)
    .build() {
}
