import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
} from "@smithy/types";
import { ChimeSDKIdentityClientResolvedConfig } from "../ChimeSDKIdentityClient";
export interface ChimeSDKIdentityHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface ChimeSDKIdentityHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    ChimeSDKIdentityClientResolvedConfig,
    HandlerExecutionContext,
    ChimeSDKIdentityHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultChimeSDKIdentityHttpAuthSchemeParametersProvider: (
  config: ChimeSDKIdentityClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<ChimeSDKIdentityHttpAuthSchemeParameters>;
export interface ChimeSDKIdentityHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<ChimeSDKIdentityHttpAuthSchemeParameters> {}
export declare const defaultChimeSDKIdentityHttpAuthSchemeProvider: ChimeSDKIdentityHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: ChimeSDKIdentityHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: ChimeSDKIdentityHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
