import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { CreateMediaConcatenationPipelineRequestFilterSensitiveLog, CreateMediaConcatenationPipelineResponseFilterSensitiveLog, } from "../models/models_0";
import { de_CreateMediaConcatenationPipelineCommand, se_CreateMediaConcatenationPipelineCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class CreateMediaConcatenationPipelineCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKMediaPipelinesService", "CreateMediaConcatenationPipeline", {})
    .n("ChimeSDKMediaPipelinesClient", "CreateMediaConcatenationPipelineCommand")
    .f(CreateMediaConcatenationPipelineRequestFilterSensitiveLog, CreateMediaConcatenationPipelineResponseFilterSensitiveLog)
    .ser(se_CreateMediaConcatenationPipelineCommand)
    .de(de_CreateMediaConcatenationPipelineCommand)
    .build() {
}
