import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { UpdateMediaInsightsPipelineConfigurationRequestFilterSensitiveLog, UpdateMediaInsightsPipelineConfigurationResponseFilterSensitiveLog, } from "../models/models_0";
import { de_UpdateMediaInsightsPipelineConfigurationCommand, se_UpdateMediaInsightsPipelineConfigurationCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class UpdateMediaInsightsPipelineConfigurationCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKMediaPipelinesService", "UpdateMediaInsightsPipelineConfiguration", {})
    .n("ChimeSDKMediaPipelinesClient", "UpdateMediaInsightsPipelineConfigurationCommand")
    .f(UpdateMediaInsightsPipelineConfigurationRequestFilterSensitiveLog, UpdateMediaInsightsPipelineConfigurationResponseFilterSensitiveLog)
    .ser(se_UpdateMediaInsightsPipelineConfigurationCommand)
    .de(de_UpdateMediaInsightsPipelineConfigurationCommand)
    .build() {
}
