import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { UpdateMediaPipelineKinesisVideoStreamPoolResponseFilterSensitiveLog, } from "../models/models_0";
import { de_UpdateMediaPipelineKinesisVideoStreamPoolCommand, se_UpdateMediaPipelineKinesisVideoStreamPoolCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class UpdateMediaPipelineKinesisVideoStreamPoolCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKMediaPipelinesService", "UpdateMediaPipelineKinesisVideoStreamPool", {})
    .n("ChimeSDKMediaPipelinesClient", "UpdateMediaPipelineKinesisVideoStreamPoolCommand")
    .f(void 0, UpdateMediaPipelineKinesisVideoStreamPoolResponseFilterSensitiveLog)
    .ser(se_UpdateMediaPipelineKinesisVideoStreamPoolCommand)
    .de(de_UpdateMediaPipelineKinesisVideoStreamPoolCommand)
    .build() {
}
