import {
  HostHeaderInputConfig,
  HostHeaderResolvedConfig,
} from "@aws-sdk/middleware-host-header";
import {
  UserAgentInputConfig,
  UserAgentResolvedConfig,
} from "@aws-sdk/middleware-user-agent";
import {
  RegionInputConfig,
  RegionResolvedConfig,
} from "@smithy/config-resolver";
import {
  EndpointInputConfig,
  EndpointResolvedConfig,
} from "@smithy/middleware-endpoint";
import {
  RetryInputConfig,
  RetryResolvedConfig,
} from "@smithy/middleware-retry";
import { HttpHandlerUserInput as __HttpHandlerUserInput } from "@smithy/protocol-http";
import {
  Client as __Client,
  DefaultsMode as __DefaultsMode,
  SmithyConfiguration as __SmithyConfiguration,
  SmithyResolvedConfiguration as __SmithyResolvedConfiguration,
} from "@smithy/smithy-client";
import {
  AwsCredentialIdentityProvider,
  BodyLengthCalculator as __BodyLengthCalculator,
  CheckOptionalClientConfig as __CheckOptionalClientConfig,
  ChecksumConstructor as __ChecksumConstructor,
  Decoder as __Decoder,
  Encoder as __Encoder,
  HashConstructor as __HashConstructor,
  HttpHandlerOptions as __HttpHandlerOptions,
  Logger as __Logger,
  Provider as __Provider,
  Provider,
  StreamCollector as __StreamCollector,
  UrlParser as __UrlParser,
  UserAgent as __UserAgent,
} from "@smithy/types";
import {
  HttpAuthSchemeInputConfig,
  HttpAuthSchemeResolvedConfig,
} from "./auth/httpAuthSchemeProvider";
import {
  CreateMediaCapturePipelineCommandInput,
  CreateMediaCapturePipelineCommandOutput,
} from "./commands/CreateMediaCapturePipelineCommand";
import {
  CreateMediaConcatenationPipelineCommandInput,
  CreateMediaConcatenationPipelineCommandOutput,
} from "./commands/CreateMediaConcatenationPipelineCommand";
import {
  CreateMediaInsightsPipelineCommandInput,
  CreateMediaInsightsPipelineCommandOutput,
} from "./commands/CreateMediaInsightsPipelineCommand";
import {
  CreateMediaInsightsPipelineConfigurationCommandInput,
  CreateMediaInsightsPipelineConfigurationCommandOutput,
} from "./commands/CreateMediaInsightsPipelineConfigurationCommand";
import {
  CreateMediaLiveConnectorPipelineCommandInput,
  CreateMediaLiveConnectorPipelineCommandOutput,
} from "./commands/CreateMediaLiveConnectorPipelineCommand";
import {
  CreateMediaPipelineKinesisVideoStreamPoolCommandInput,
  CreateMediaPipelineKinesisVideoStreamPoolCommandOutput,
} from "./commands/CreateMediaPipelineKinesisVideoStreamPoolCommand";
import {
  CreateMediaStreamPipelineCommandInput,
  CreateMediaStreamPipelineCommandOutput,
} from "./commands/CreateMediaStreamPipelineCommand";
import {
  DeleteMediaCapturePipelineCommandInput,
  DeleteMediaCapturePipelineCommandOutput,
} from "./commands/DeleteMediaCapturePipelineCommand";
import {
  DeleteMediaInsightsPipelineConfigurationCommandInput,
  DeleteMediaInsightsPipelineConfigurationCommandOutput,
} from "./commands/DeleteMediaInsightsPipelineConfigurationCommand";
import {
  DeleteMediaPipelineCommandInput,
  DeleteMediaPipelineCommandOutput,
} from "./commands/DeleteMediaPipelineCommand";
import {
  DeleteMediaPipelineKinesisVideoStreamPoolCommandInput,
  DeleteMediaPipelineKinesisVideoStreamPoolCommandOutput,
} from "./commands/DeleteMediaPipelineKinesisVideoStreamPoolCommand";
import {
  GetMediaCapturePipelineCommandInput,
  GetMediaCapturePipelineCommandOutput,
} from "./commands/GetMediaCapturePipelineCommand";
import {
  GetMediaInsightsPipelineConfigurationCommandInput,
  GetMediaInsightsPipelineConfigurationCommandOutput,
} from "./commands/GetMediaInsightsPipelineConfigurationCommand";
import {
  GetMediaPipelineCommandInput,
  GetMediaPipelineCommandOutput,
} from "./commands/GetMediaPipelineCommand";
import {
  GetMediaPipelineKinesisVideoStreamPoolCommandInput,
  GetMediaPipelineKinesisVideoStreamPoolCommandOutput,
} from "./commands/GetMediaPipelineKinesisVideoStreamPoolCommand";
import {
  GetSpeakerSearchTaskCommandInput,
  GetSpeakerSearchTaskCommandOutput,
} from "./commands/GetSpeakerSearchTaskCommand";
import {
  GetVoiceToneAnalysisTaskCommandInput,
  GetVoiceToneAnalysisTaskCommandOutput,
} from "./commands/GetVoiceToneAnalysisTaskCommand";
import {
  ListMediaCapturePipelinesCommandInput,
  ListMediaCapturePipelinesCommandOutput,
} from "./commands/ListMediaCapturePipelinesCommand";
import {
  ListMediaInsightsPipelineConfigurationsCommandInput,
  ListMediaInsightsPipelineConfigurationsCommandOutput,
} from "./commands/ListMediaInsightsPipelineConfigurationsCommand";
import {
  ListMediaPipelineKinesisVideoStreamPoolsCommandInput,
  ListMediaPipelineKinesisVideoStreamPoolsCommandOutput,
} from "./commands/ListMediaPipelineKinesisVideoStreamPoolsCommand";
import {
  ListMediaPipelinesCommandInput,
  ListMediaPipelinesCommandOutput,
} from "./commands/ListMediaPipelinesCommand";
import {
  ListTagsForResourceCommandInput,
  ListTagsForResourceCommandOutput,
} from "./commands/ListTagsForResourceCommand";
import {
  StartSpeakerSearchTaskCommandInput,
  StartSpeakerSearchTaskCommandOutput,
} from "./commands/StartSpeakerSearchTaskCommand";
import {
  StartVoiceToneAnalysisTaskCommandInput,
  StartVoiceToneAnalysisTaskCommandOutput,
} from "./commands/StartVoiceToneAnalysisTaskCommand";
import {
  StopSpeakerSearchTaskCommandInput,
  StopSpeakerSearchTaskCommandOutput,
} from "./commands/StopSpeakerSearchTaskCommand";
import {
  StopVoiceToneAnalysisTaskCommandInput,
  StopVoiceToneAnalysisTaskCommandOutput,
} from "./commands/StopVoiceToneAnalysisTaskCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "./commands/TagResourceCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "./commands/UntagResourceCommand";
import {
  UpdateMediaInsightsPipelineConfigurationCommandInput,
  UpdateMediaInsightsPipelineConfigurationCommandOutput,
} from "./commands/UpdateMediaInsightsPipelineConfigurationCommand";
import {
  UpdateMediaInsightsPipelineStatusCommandInput,
  UpdateMediaInsightsPipelineStatusCommandOutput,
} from "./commands/UpdateMediaInsightsPipelineStatusCommand";
import {
  UpdateMediaPipelineKinesisVideoStreamPoolCommandInput,
  UpdateMediaPipelineKinesisVideoStreamPoolCommandOutput,
} from "./commands/UpdateMediaPipelineKinesisVideoStreamPoolCommand";
import {
  ClientInputEndpointParameters,
  ClientResolvedEndpointParameters,
  EndpointParameters,
} from "./endpoint/EndpointParameters";
import { RuntimeExtension, RuntimeExtensionsConfig } from "./runtimeExtensions";
export { __Client };
export type ServiceInputTypes =
  | CreateMediaCapturePipelineCommandInput
  | CreateMediaConcatenationPipelineCommandInput
  | CreateMediaInsightsPipelineCommandInput
  | CreateMediaInsightsPipelineConfigurationCommandInput
  | CreateMediaLiveConnectorPipelineCommandInput
  | CreateMediaPipelineKinesisVideoStreamPoolCommandInput
  | CreateMediaStreamPipelineCommandInput
  | DeleteMediaCapturePipelineCommandInput
  | DeleteMediaInsightsPipelineConfigurationCommandInput
  | DeleteMediaPipelineCommandInput
  | DeleteMediaPipelineKinesisVideoStreamPoolCommandInput
  | GetMediaCapturePipelineCommandInput
  | GetMediaInsightsPipelineConfigurationCommandInput
  | GetMediaPipelineCommandInput
  | GetMediaPipelineKinesisVideoStreamPoolCommandInput
  | GetSpeakerSearchTaskCommandInput
  | GetVoiceToneAnalysisTaskCommandInput
  | ListMediaCapturePipelinesCommandInput
  | ListMediaInsightsPipelineConfigurationsCommandInput
  | ListMediaPipelineKinesisVideoStreamPoolsCommandInput
  | ListMediaPipelinesCommandInput
  | ListTagsForResourceCommandInput
  | StartSpeakerSearchTaskCommandInput
  | StartVoiceToneAnalysisTaskCommandInput
  | StopSpeakerSearchTaskCommandInput
  | StopVoiceToneAnalysisTaskCommandInput
  | TagResourceCommandInput
  | UntagResourceCommandInput
  | UpdateMediaInsightsPipelineConfigurationCommandInput
  | UpdateMediaInsightsPipelineStatusCommandInput
  | UpdateMediaPipelineKinesisVideoStreamPoolCommandInput;
export type ServiceOutputTypes =
  | CreateMediaCapturePipelineCommandOutput
  | CreateMediaConcatenationPipelineCommandOutput
  | CreateMediaInsightsPipelineCommandOutput
  | CreateMediaInsightsPipelineConfigurationCommandOutput
  | CreateMediaLiveConnectorPipelineCommandOutput
  | CreateMediaPipelineKinesisVideoStreamPoolCommandOutput
  | CreateMediaStreamPipelineCommandOutput
  | DeleteMediaCapturePipelineCommandOutput
  | DeleteMediaInsightsPipelineConfigurationCommandOutput
  | DeleteMediaPipelineCommandOutput
  | DeleteMediaPipelineKinesisVideoStreamPoolCommandOutput
  | GetMediaCapturePipelineCommandOutput
  | GetMediaInsightsPipelineConfigurationCommandOutput
  | GetMediaPipelineCommandOutput
  | GetMediaPipelineKinesisVideoStreamPoolCommandOutput
  | GetSpeakerSearchTaskCommandOutput
  | GetVoiceToneAnalysisTaskCommandOutput
  | ListMediaCapturePipelinesCommandOutput
  | ListMediaInsightsPipelineConfigurationsCommandOutput
  | ListMediaPipelineKinesisVideoStreamPoolsCommandOutput
  | ListMediaPipelinesCommandOutput
  | ListTagsForResourceCommandOutput
  | StartSpeakerSearchTaskCommandOutput
  | StartVoiceToneAnalysisTaskCommandOutput
  | StopSpeakerSearchTaskCommandOutput
  | StopVoiceToneAnalysisTaskCommandOutput
  | TagResourceCommandOutput
  | UntagResourceCommandOutput
  | UpdateMediaInsightsPipelineConfigurationCommandOutput
  | UpdateMediaInsightsPipelineStatusCommandOutput
  | UpdateMediaPipelineKinesisVideoStreamPoolCommandOutput;
export interface ClientDefaults
  extends Partial<__SmithyConfiguration<__HttpHandlerOptions>> {
  requestHandler?: __HttpHandlerUserInput;
  sha256?: __ChecksumConstructor | __HashConstructor;
  urlParser?: __UrlParser;
  bodyLengthChecker?: __BodyLengthCalculator;
  streamCollector?: __StreamCollector;
  base64Decoder?: __Decoder;
  base64Encoder?: __Encoder;
  utf8Decoder?: __Decoder;
  utf8Encoder?: __Encoder;
  runtime?: string;
  disableHostPrefix?: boolean;
  serviceId?: string;
  useDualstackEndpoint?: boolean | __Provider<boolean>;
  useFipsEndpoint?: boolean | __Provider<boolean>;
  region?: string | __Provider<string>;
  defaultUserAgentProvider?: Provider<__UserAgent>;
  credentialDefaultProvider?: (input: any) => AwsCredentialIdentityProvider;
  maxAttempts?: number | __Provider<number>;
  retryMode?: string | __Provider<string>;
  logger?: __Logger;
  extensions?: RuntimeExtension[];
  defaultsMode?: __DefaultsMode | __Provider<__DefaultsMode>;
}
export type ChimeSDKMediaPipelinesClientConfigType = Partial<
  __SmithyConfiguration<__HttpHandlerOptions>
> &
  ClientDefaults &
  RegionInputConfig &
  EndpointInputConfig<EndpointParameters> &
  RetryInputConfig &
  HostHeaderInputConfig &
  UserAgentInputConfig &
  HttpAuthSchemeInputConfig &
  ClientInputEndpointParameters;
export interface ChimeSDKMediaPipelinesClientConfig
  extends ChimeSDKMediaPipelinesClientConfigType {}
export type ChimeSDKMediaPipelinesClientResolvedConfigType =
  __SmithyResolvedConfiguration<__HttpHandlerOptions> &
    Required<ClientDefaults> &
    RuntimeExtensionsConfig &
    RegionResolvedConfig &
    EndpointResolvedConfig<EndpointParameters> &
    RetryResolvedConfig &
    HostHeaderResolvedConfig &
    UserAgentResolvedConfig &
    HttpAuthSchemeResolvedConfig &
    ClientResolvedEndpointParameters;
export interface ChimeSDKMediaPipelinesClientResolvedConfig
  extends ChimeSDKMediaPipelinesClientResolvedConfigType {}
export declare class ChimeSDKMediaPipelinesClient extends __Client<
  __HttpHandlerOptions,
  ServiceInputTypes,
  ServiceOutputTypes,
  ChimeSDKMediaPipelinesClientResolvedConfig
> {
  readonly config: ChimeSDKMediaPipelinesClientResolvedConfig;
  constructor(
    ...[
      configuration,
    ]: __CheckOptionalClientConfig<ChimeSDKMediaPipelinesClientConfig>
  );
  destroy(): void;
  private getDefaultHttpAuthSchemeParametersProvider;
  private getIdentityProviderConfigProvider;
}
