import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
} from "@smithy/types";
import { ChimeSDKMediaPipelinesClientResolvedConfig } from "../ChimeSDKMediaPipelinesClient";
export interface ChimeSDKMediaPipelinesHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface ChimeSDKMediaPipelinesHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    ChimeSDKMediaPipelinesClientResolvedConfig,
    HandlerExecutionContext,
    ChimeSDKMediaPipelinesHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultChimeSDKMediaPipelinesHttpAuthSchemeParametersProvider: (
  config: ChimeSDKMediaPipelinesClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<ChimeSDKMediaPipelinesHttpAuthSchemeParameters>;
export interface ChimeSDKMediaPipelinesHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<ChimeSDKMediaPipelinesHttpAuthSchemeParameters> {}
export declare const defaultChimeSDKMediaPipelinesHttpAuthSchemeProvider: ChimeSDKMediaPipelinesHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: ChimeSDKMediaPipelinesHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: ChimeSDKMediaPipelinesHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
