import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { AssociatePhoneNumbersWithVoiceConnectorRequestFilterSensitiveLog, AssociatePhoneNumbersWithVoiceConnectorResponseFilterSensitiveLog, } from "../models/models_0";
import { de_AssociatePhoneNumbersWithVoiceConnectorCommand, se_AssociatePhoneNumbersWithVoiceConnectorCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class AssociatePhoneNumbersWithVoiceConnectorCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "AssociatePhoneNumbersWithVoiceConnector", {})
    .n("ChimeSDKVoiceClient", "AssociatePhoneNumbersWithVoiceConnectorCommand")
    .f(AssociatePhoneNumbersWithVoiceConnectorRequestFilterSensitiveLog, AssociatePhoneNumbersWithVoiceConnectorResponseFilterSensitiveLog)
    .ser(se_AssociatePhoneNumbersWithVoiceConnectorCommand)
    .de(de_AssociatePhoneNumbersWithVoiceConnectorCommand)
    .build() {
}
