import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { CreatePhoneNumberOrderRequestFilterSensitiveLog, CreatePhoneNumberOrderResponseFilterSensitiveLog, } from "../models/models_0";
import { de_CreatePhoneNumberOrderCommand, se_CreatePhoneNumberOrderCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class CreatePhoneNumberOrderCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "CreatePhoneNumberOrder", {})
    .n("ChimeSDKVoiceClient", "CreatePhoneNumberOrderCommand")
    .f(CreatePhoneNumberOrderRequestFilterSensitiveLog, CreatePhoneNumberOrderResponseFilterSensitiveLog)
    .ser(se_CreatePhoneNumberOrderCommand)
    .de(de_CreatePhoneNumberOrderCommand)
    .build() {
}
