import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { CreateVoiceConnectorRequestFilterSensitiveLog, } from "../models/models_0";
import { de_CreateVoiceConnectorCommand, se_CreateVoiceConnectorCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class CreateVoiceConnectorCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "CreateVoiceConnector", {})
    .n("ChimeSDKVoiceClient", "CreateVoiceConnectorCommand")
    .f(CreateVoiceConnectorRequestFilterSensitiveLog, void 0)
    .ser(se_CreateVoiceConnectorCommand)
    .de(de_CreateVoiceConnectorCommand)
    .build() {
}
