import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetSipMediaApplicationAlexaSkillConfigurationResponseFilterSensitiveLog, } from "../models/models_0";
import { de_GetSipMediaApplicationAlexaSkillConfigurationCommand, se_GetSipMediaApplicationAlexaSkillConfigurationCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class GetSipMediaApplicationAlexaSkillConfigurationCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "GetSipMediaApplicationAlexaSkillConfiguration", {})
    .n("ChimeSDKVoiceClient", "GetSipMediaApplicationAlexaSkillConfigurationCommand")
    .f(void 0, GetSipMediaApplicationAlexaSkillConfigurationResponseFilterSensitiveLog)
    .ser(se_GetSipMediaApplicationAlexaSkillConfigurationCommand)
    .de(de_GetSipMediaApplicationAlexaSkillConfigurationCommand)
    .build() {
}
