import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetVoiceProfileDomainResponseFilterSensitiveLog, } from "../models/models_0";
import { de_GetVoiceProfileDomainCommand, se_GetVoiceProfileDomainCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class GetVoiceProfileDomainCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "GetVoiceProfileDomain", {})
    .n("ChimeSDKVoiceClient", "GetVoiceProfileDomainCommand")
    .f(void 0, GetVoiceProfileDomainResponseFilterSensitiveLog)
    .ser(se_GetVoiceProfileDomainCommand)
    .de(de_GetVoiceProfileDomainCommand)
    .build() {
}
