import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { ListPhoneNumberOrdersResponseFilterSensitiveLog, } from "../models/models_0";
import { de_ListPhoneNumberOrdersCommand, se_ListPhoneNumberOrdersCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class ListPhoneNumberOrdersCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "ListPhoneNumberOrders", {})
    .n("ChimeSDKVoiceClient", "ListPhoneNumberOrdersCommand")
    .f(void 0, ListPhoneNumberOrdersResponseFilterSensitiveLog)
    .ser(se_ListPhoneNumberOrdersCommand)
    .de(de_ListPhoneNumberOrdersCommand)
    .build() {
}
