import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { ListVoiceConnectorTerminationCredentialsResponseFilterSensitiveLog, } from "../models/models_0";
import { de_ListVoiceConnectorTerminationCredentialsCommand, se_ListVoiceConnectorTerminationCredentialsCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class ListVoiceConnectorTerminationCredentialsCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "ListVoiceConnectorTerminationCredentials", {})
    .n("ChimeSDKVoiceClient", "ListVoiceConnectorTerminationCredentialsCommand")
    .f(void 0, ListVoiceConnectorTerminationCredentialsResponseFilterSensitiveLog)
    .ser(se_ListVoiceConnectorTerminationCredentialsCommand)
    .de(de_ListVoiceConnectorTerminationCredentialsCommand)
    .build() {
}
