import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { ListVoiceProfilesResponseFilterSensitiveLog, } from "../models/models_0";
import { de_ListVoiceProfilesCommand, se_ListVoiceProfilesCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class ListVoiceProfilesCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "ListVoiceProfiles", {})
    .n("ChimeSDKVoiceClient", "ListVoiceProfilesCommand")
    .f(void 0, ListVoiceProfilesResponseFilterSensitiveLog)
    .ser(se_ListVoiceProfilesCommand)
    .de(de_ListVoiceProfilesCommand)
    .build() {
}
