import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { PutVoiceConnectorEmergencyCallingConfigurationRequestFilterSensitiveLog, PutVoiceConnectorEmergencyCallingConfigurationResponseFilterSensitiveLog, } from "../models/models_0";
import { de_PutVoiceConnectorEmergencyCallingConfigurationCommand, se_PutVoiceConnectorEmergencyCallingConfigurationCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class PutVoiceConnectorEmergencyCallingConfigurationCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "PutVoiceConnectorEmergencyCallingConfiguration", {})
    .n("ChimeSDKVoiceClient", "PutVoiceConnectorEmergencyCallingConfigurationCommand")
    .f(PutVoiceConnectorEmergencyCallingConfigurationRequestFilterSensitiveLog, PutVoiceConnectorEmergencyCallingConfigurationResponseFilterSensitiveLog)
    .ser(se_PutVoiceConnectorEmergencyCallingConfigurationCommand)
    .de(de_PutVoiceConnectorEmergencyCallingConfigurationCommand)
    .build() {
}
