import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { PutVoiceConnectorTerminationRequestFilterSensitiveLog, PutVoiceConnectorTerminationResponseFilterSensitiveLog, } from "../models/models_0";
import { de_PutVoiceConnectorTerminationCommand, se_PutVoiceConnectorTerminationCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class PutVoiceConnectorTerminationCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "PutVoiceConnectorTermination", {})
    .n("ChimeSDKVoiceClient", "PutVoiceConnectorTerminationCommand")
    .f(PutVoiceConnectorTerminationRequestFilterSensitiveLog, PutVoiceConnectorTerminationResponseFilterSensitiveLog)
    .ser(se_PutVoiceConnectorTerminationCommand)
    .de(de_PutVoiceConnectorTerminationCommand)
    .build() {
}
