import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { UpdateSipMediaApplicationRequestFilterSensitiveLog, UpdateSipMediaApplicationResponseFilterSensitiveLog, } from "../models/models_0";
import { de_UpdateSipMediaApplicationCommand, se_UpdateSipMediaApplicationCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class UpdateSipMediaApplicationCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "UpdateSipMediaApplication", {})
    .n("ChimeSDKVoiceClient", "UpdateSipMediaApplicationCommand")
    .f(UpdateSipMediaApplicationRequestFilterSensitiveLog, UpdateSipMediaApplicationResponseFilterSensitiveLog)
    .ser(se_UpdateSipMediaApplicationCommand)
    .de(de_UpdateSipMediaApplicationCommand)
    .build() {
}
