import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { UpdateVoiceProfileResponseFilterSensitiveLog, } from "../models/models_0";
import { de_UpdateVoiceProfileCommand, se_UpdateVoiceProfileCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class UpdateVoiceProfileCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "UpdateVoiceProfile", {})
    .n("ChimeSDKVoiceClient", "UpdateVoiceProfileCommand")
    .f(void 0, UpdateVoiceProfileResponseFilterSensitiveLog)
    .ser(se_UpdateVoiceProfileCommand)
    .de(de_UpdateVoiceProfileCommand)
    .build() {
}
