import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
} from "@smithy/types";
import { ChimeSDKVoiceClientResolvedConfig } from "../ChimeSDKVoiceClient";
export interface ChimeSDKVoiceHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface ChimeSDKVoiceHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    ChimeSDKVoiceClientResolvedConfig,
    HandlerExecutionContext,
    ChimeSDKVoiceHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultChimeSDKVoiceHttpAuthSchemeParametersProvider: (
  config: ChimeSDKVoiceClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<ChimeSDKVoiceHttpAuthSchemeParameters>;
export interface ChimeSDKVoiceHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<ChimeSDKVoiceHttpAuthSchemeParameters> {}
export declare const defaultChimeSDKVoiceHttpAuthSchemeProvider: ChimeSDKVoiceHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: ChimeSDKVoiceHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: ChimeSDKVoiceHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
