import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { CreateSignalingChannelCommandInput, CreateSignalingChannelCommandOutput } from "../commands/CreateSignalingChannelCommand";
import { CreateStreamCommandInput, CreateStreamCommandOutput } from "../commands/CreateStreamCommand";
import { DeleteEdgeConfigurationCommandInput, DeleteEdgeConfigurationCommandOutput } from "../commands/DeleteEdgeConfigurationCommand";
import { DeleteSignalingChannelCommandInput, DeleteSignalingChannelCommandOutput } from "../commands/DeleteSignalingChannelCommand";
import { DeleteStreamCommandInput, DeleteStreamCommandOutput } from "../commands/DeleteStreamCommand";
import { DescribeEdgeConfigurationCommandInput, DescribeEdgeConfigurationCommandOutput } from "../commands/DescribeEdgeConfigurationCommand";
import { DescribeImageGenerationConfigurationCommandInput, DescribeImageGenerationConfigurationCommandOutput } from "../commands/DescribeImageGenerationConfigurationCommand";
import { DescribeMappedResourceConfigurationCommandInput, DescribeMappedResourceConfigurationCommandOutput } from "../commands/DescribeMappedResourceConfigurationCommand";
import { DescribeMediaStorageConfigurationCommandInput, DescribeMediaStorageConfigurationCommandOutput } from "../commands/DescribeMediaStorageConfigurationCommand";
import { DescribeNotificationConfigurationCommandInput, DescribeNotificationConfigurationCommandOutput } from "../commands/DescribeNotificationConfigurationCommand";
import { DescribeSignalingChannelCommandInput, DescribeSignalingChannelCommandOutput } from "../commands/DescribeSignalingChannelCommand";
import { DescribeStreamCommandInput, DescribeStreamCommandOutput } from "../commands/DescribeStreamCommand";
import { GetDataEndpointCommandInput, GetDataEndpointCommandOutput } from "../commands/GetDataEndpointCommand";
import { GetSignalingChannelEndpointCommandInput, GetSignalingChannelEndpointCommandOutput } from "../commands/GetSignalingChannelEndpointCommand";
import { ListEdgeAgentConfigurationsCommandInput, ListEdgeAgentConfigurationsCommandOutput } from "../commands/ListEdgeAgentConfigurationsCommand";
import { ListSignalingChannelsCommandInput, ListSignalingChannelsCommandOutput } from "../commands/ListSignalingChannelsCommand";
import { ListStreamsCommandInput, ListStreamsCommandOutput } from "../commands/ListStreamsCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { ListTagsForStreamCommandInput, ListTagsForStreamCommandOutput } from "../commands/ListTagsForStreamCommand";
import { StartEdgeConfigurationUpdateCommandInput, StartEdgeConfigurationUpdateCommandOutput } from "../commands/StartEdgeConfigurationUpdateCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { TagStreamCommandInput, TagStreamCommandOutput } from "../commands/TagStreamCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UntagStreamCommandInput, UntagStreamCommandOutput } from "../commands/UntagStreamCommand";
import { UpdateDataRetentionCommandInput, UpdateDataRetentionCommandOutput } from "../commands/UpdateDataRetentionCommand";
import { UpdateImageGenerationConfigurationCommandInput, UpdateImageGenerationConfigurationCommandOutput } from "../commands/UpdateImageGenerationConfigurationCommand";
import { UpdateMediaStorageConfigurationCommandInput, UpdateMediaStorageConfigurationCommandOutput } from "../commands/UpdateMediaStorageConfigurationCommand";
import { UpdateNotificationConfigurationCommandInput, UpdateNotificationConfigurationCommandOutput } from "../commands/UpdateNotificationConfigurationCommand";
import { UpdateSignalingChannelCommandInput, UpdateSignalingChannelCommandOutput } from "../commands/UpdateSignalingChannelCommand";
import { UpdateStreamCommandInput, UpdateStreamCommandOutput } from "../commands/UpdateStreamCommand";
/**
 * serializeAws_restJson1CreateSignalingChannelCommand
 */
export declare const se_CreateSignalingChannelCommand: (input: CreateSignalingChannelCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateStreamCommand
 */
export declare const se_CreateStreamCommand: (input: CreateStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteEdgeConfigurationCommand
 */
export declare const se_DeleteEdgeConfigurationCommand: (input: DeleteEdgeConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteSignalingChannelCommand
 */
export declare const se_DeleteSignalingChannelCommand: (input: DeleteSignalingChannelCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteStreamCommand
 */
export declare const se_DeleteStreamCommand: (input: DeleteStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeEdgeConfigurationCommand
 */
export declare const se_DescribeEdgeConfigurationCommand: (input: DescribeEdgeConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeImageGenerationConfigurationCommand
 */
export declare const se_DescribeImageGenerationConfigurationCommand: (input: DescribeImageGenerationConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeMappedResourceConfigurationCommand
 */
export declare const se_DescribeMappedResourceConfigurationCommand: (input: DescribeMappedResourceConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeMediaStorageConfigurationCommand
 */
export declare const se_DescribeMediaStorageConfigurationCommand: (input: DescribeMediaStorageConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeNotificationConfigurationCommand
 */
export declare const se_DescribeNotificationConfigurationCommand: (input: DescribeNotificationConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeSignalingChannelCommand
 */
export declare const se_DescribeSignalingChannelCommand: (input: DescribeSignalingChannelCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeStreamCommand
 */
export declare const se_DescribeStreamCommand: (input: DescribeStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetDataEndpointCommand
 */
export declare const se_GetDataEndpointCommand: (input: GetDataEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetSignalingChannelEndpointCommand
 */
export declare const se_GetSignalingChannelEndpointCommand: (input: GetSignalingChannelEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListEdgeAgentConfigurationsCommand
 */
export declare const se_ListEdgeAgentConfigurationsCommand: (input: ListEdgeAgentConfigurationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListSignalingChannelsCommand
 */
export declare const se_ListSignalingChannelsCommand: (input: ListSignalingChannelsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListStreamsCommand
 */
export declare const se_ListStreamsCommand: (input: ListStreamsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListTagsForResourceCommand
 */
export declare const se_ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListTagsForStreamCommand
 */
export declare const se_ListTagsForStreamCommand: (input: ListTagsForStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1StartEdgeConfigurationUpdateCommand
 */
export declare const se_StartEdgeConfigurationUpdateCommand: (input: StartEdgeConfigurationUpdateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1TagResourceCommand
 */
export declare const se_TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1TagStreamCommand
 */
export declare const se_TagStreamCommand: (input: TagStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UntagResourceCommand
 */
export declare const se_UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UntagStreamCommand
 */
export declare const se_UntagStreamCommand: (input: UntagStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateDataRetentionCommand
 */
export declare const se_UpdateDataRetentionCommand: (input: UpdateDataRetentionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateImageGenerationConfigurationCommand
 */
export declare const se_UpdateImageGenerationConfigurationCommand: (input: UpdateImageGenerationConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateMediaStorageConfigurationCommand
 */
export declare const se_UpdateMediaStorageConfigurationCommand: (input: UpdateMediaStorageConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateNotificationConfigurationCommand
 */
export declare const se_UpdateNotificationConfigurationCommand: (input: UpdateNotificationConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateSignalingChannelCommand
 */
export declare const se_UpdateSignalingChannelCommand: (input: UpdateSignalingChannelCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateStreamCommand
 */
export declare const se_UpdateStreamCommand: (input: UpdateStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_restJson1CreateSignalingChannelCommand
 */
export declare const de_CreateSignalingChannelCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateSignalingChannelCommandOutput>;
/**
 * deserializeAws_restJson1CreateStreamCommand
 */
export declare const de_CreateStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateStreamCommandOutput>;
/**
 * deserializeAws_restJson1DeleteEdgeConfigurationCommand
 */
export declare const de_DeleteEdgeConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteEdgeConfigurationCommandOutput>;
/**
 * deserializeAws_restJson1DeleteSignalingChannelCommand
 */
export declare const de_DeleteSignalingChannelCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteSignalingChannelCommandOutput>;
/**
 * deserializeAws_restJson1DeleteStreamCommand
 */
export declare const de_DeleteStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteStreamCommandOutput>;
/**
 * deserializeAws_restJson1DescribeEdgeConfigurationCommand
 */
export declare const de_DescribeEdgeConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeEdgeConfigurationCommandOutput>;
/**
 * deserializeAws_restJson1DescribeImageGenerationConfigurationCommand
 */
export declare const de_DescribeImageGenerationConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeImageGenerationConfigurationCommandOutput>;
/**
 * deserializeAws_restJson1DescribeMappedResourceConfigurationCommand
 */
export declare const de_DescribeMappedResourceConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeMappedResourceConfigurationCommandOutput>;
/**
 * deserializeAws_restJson1DescribeMediaStorageConfigurationCommand
 */
export declare const de_DescribeMediaStorageConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeMediaStorageConfigurationCommandOutput>;
/**
 * deserializeAws_restJson1DescribeNotificationConfigurationCommand
 */
export declare const de_DescribeNotificationConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeNotificationConfigurationCommandOutput>;
/**
 * deserializeAws_restJson1DescribeSignalingChannelCommand
 */
export declare const de_DescribeSignalingChannelCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeSignalingChannelCommandOutput>;
/**
 * deserializeAws_restJson1DescribeStreamCommand
 */
export declare const de_DescribeStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeStreamCommandOutput>;
/**
 * deserializeAws_restJson1GetDataEndpointCommand
 */
export declare const de_GetDataEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDataEndpointCommandOutput>;
/**
 * deserializeAws_restJson1GetSignalingChannelEndpointCommand
 */
export declare const de_GetSignalingChannelEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetSignalingChannelEndpointCommandOutput>;
/**
 * deserializeAws_restJson1ListEdgeAgentConfigurationsCommand
 */
export declare const de_ListEdgeAgentConfigurationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListEdgeAgentConfigurationsCommandOutput>;
/**
 * deserializeAws_restJson1ListSignalingChannelsCommand
 */
export declare const de_ListSignalingChannelsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListSignalingChannelsCommandOutput>;
/**
 * deserializeAws_restJson1ListStreamsCommand
 */
export declare const de_ListStreamsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListStreamsCommandOutput>;
/**
 * deserializeAws_restJson1ListTagsForResourceCommand
 */
export declare const de_ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
/**
 * deserializeAws_restJson1ListTagsForStreamCommand
 */
export declare const de_ListTagsForStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForStreamCommandOutput>;
/**
 * deserializeAws_restJson1StartEdgeConfigurationUpdateCommand
 */
export declare const de_StartEdgeConfigurationUpdateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartEdgeConfigurationUpdateCommandOutput>;
/**
 * deserializeAws_restJson1TagResourceCommand
 */
export declare const de_TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
/**
 * deserializeAws_restJson1TagStreamCommand
 */
export declare const de_TagStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagStreamCommandOutput>;
/**
 * deserializeAws_restJson1UntagResourceCommand
 */
export declare const de_UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
/**
 * deserializeAws_restJson1UntagStreamCommand
 */
export declare const de_UntagStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagStreamCommandOutput>;
/**
 * deserializeAws_restJson1UpdateDataRetentionCommand
 */
export declare const de_UpdateDataRetentionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateDataRetentionCommandOutput>;
/**
 * deserializeAws_restJson1UpdateImageGenerationConfigurationCommand
 */
export declare const de_UpdateImageGenerationConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateImageGenerationConfigurationCommandOutput>;
/**
 * deserializeAws_restJson1UpdateMediaStorageConfigurationCommand
 */
export declare const de_UpdateMediaStorageConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateMediaStorageConfigurationCommandOutput>;
/**
 * deserializeAws_restJson1UpdateNotificationConfigurationCommand
 */
export declare const de_UpdateNotificationConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateNotificationConfigurationCommandOutput>;
/**
 * deserializeAws_restJson1UpdateSignalingChannelCommand
 */
export declare const de_UpdateSignalingChannelCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateSignalingChannelCommandOutput>;
/**
 * deserializeAws_restJson1UpdateStreamCommand
 */
export declare const de_UpdateStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateStreamCommandOutput>;
