import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
} from "@smithy/types";
import { KinesisVideoClientResolvedConfig } from "../KinesisVideoClient";
export interface KinesisVideoHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface KinesisVideoHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    KinesisVideoClientResolvedConfig,
    HandlerExecutionContext,
    KinesisVideoHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultKinesisVideoHttpAuthSchemeParametersProvider: (
  config: KinesisVideoClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<KinesisVideoHttpAuthSchemeParameters>;
export interface KinesisVideoHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<KinesisVideoHttpAuthSchemeParameters> {}
export declare const defaultKinesisVideoHttpAuthSchemeProvider: KinesisVideoHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: KinesisVideoHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: KinesisVideoHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
